/* UFO Extender - Mod for X-COM
 * See <http://www.ufopaedia.org/index.php?title=User:Seb76> for more details.
 * Copyright (C) 2008 Seb76
 *
 * This file is part of UFO Extender.

 * UFO Extender is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * UFO Extender is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with UFO Extender.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "stdafx.h"
#include "xcom.h"
#include "patcher.h"

#define SHORTCUT_ENDTURN 1
#define SHORTCUT_MULTILEVELVIEW 2
#define SHORTCUT_SHOWMAP 3
#define SHORTCUT_CENTER 4
#define SHORTCUT_INVENTORY 5
#define SHORTCUT_KNEEL 6
#define SHORTCUT_NEXT 7
#define SHORTCUT_NEXT_SKIP 8
#define SHORTCUT_VIEWUP 9
#define SHORTCUT_VIEWDOWN 10
#define SHORTCUT_GOUP 11
#define SHORTCUT_GODOWN 12
#define SHORTCUT_LEFTMENU 13
#define SHORTCUT_RIGHTMENU 14
#define SHORTCUT_STATS 15
#define SHORTCUT_OPTIONS 16
#define SHORTCUT_LIFTOFF 17
#define SHORTCUT_RESERVENONE 18
#define SHORTCUT_RESERVESNAP 19
#define SHORTCUT_RESERVEAUTO 20
#define SHORTCUT_RESERVEAIMED 21

static int geo_hook_disabled = 0;
static short shortcut=-1;
static short geoShortcut=-1;
static int isSavingGame=0;
static unsigned char keyToShortcut[256];
static unsigned char keyToGeoShortcut[256];

#define GEO_SHORTCUT_ROTATELEFT 1
#define GEO_SHORTCUT_ROTATERIGHT 2
#define GEO_SHORTCUT_ROTATEUP 3
#define GEO_SHORTCUT_ROTATEDOWN 4
#define GEO_SHORTCUT_ZOOMIN 5
#define GEO_SHORTCUT_ZOOMOUT 6
#define GEO_SHORTCUT_SPEED1 7
#define GEO_SHORTCUT_SPEED2 8
#define GEO_SHORTCUT_SPEED3 9
#define GEO_SHORTCUT_SPEED4 10
#define GEO_SHORTCUT_SPEED5 11
#define GEO_SHORTCUT_SPEED6 12
#define GEO_SHORTCUT_INTERCEPT 13
#define GEO_SHORTCUT_BASES 14
#define GEO_SHORTCUT_GRAPHS 15
#define GEO_SHORTCUT_UFOPAEDIA 16
#define GEO_SHORTCUT_OPTIONS 17
#define GEO_SHORTCUT_FUNDINGS 18


#define MAPKEY(name,vk) if(!stricmp(str,name)) return vk;
static unsigned char strToVk(const char *str)
{
	MAPKEY("Back",VK_BACK);
	MAPKEY("BackSpace",VK_BACK);
	MAPKEY("Back Space",VK_BACK);
	MAPKEY("Tab",VK_TAB);
	MAPKEY("Clear",VK_CLEAR);
	MAPKEY("Return",VK_RETURN);
	MAPKEY("Enter",VK_RETURN);
	MAPKEY("Shift",VK_SHIFT);
	MAPKEY("Control",VK_CONTROL);
	MAPKEY("Menu",VK_MENU);
	MAPKEY("Pause",VK_PAUSE);
	MAPKEY("Escape",VK_ESCAPE);
	MAPKEY("Space",VK_SPACE);
	MAPKEY("Prior",VK_PRIOR);
	MAPKEY("PageUp",VK_PRIOR);
	MAPKEY("Next",VK_NEXT);
	MAPKEY("PageDown",VK_NEXT);
	MAPKEY("End",VK_END);
	MAPKEY("Home",VK_HOME);
	MAPKEY("Left",VK_LEFT);
	MAPKEY("Up",VK_UP);
	MAPKEY("Right",VK_RIGHT);
	MAPKEY("Down",VK_DOWN);
	MAPKEY("Print",VK_PRINT);
	MAPKEY("Insert",VK_INSERT);
	MAPKEY("Delete",VK_DELETE);
	MAPKEY("Num0",VK_NUMPAD0);
	MAPKEY("Numpad0",VK_NUMPAD0);
	MAPKEY("Num1",VK_NUMPAD1);
	MAPKEY("Numpad1",VK_NUMPAD1);
	MAPKEY("Num2",VK_NUMPAD2);
	MAPKEY("Numpad2",VK_NUMPAD2);
	MAPKEY("Num3",VK_NUMPAD3);
	MAPKEY("Numpad3",VK_NUMPAD3);
	MAPKEY("Num4",VK_NUMPAD4);
	MAPKEY("Numpad4",VK_NUMPAD4);
	MAPKEY("Num5",VK_NUMPAD5);
	MAPKEY("Numpad5",VK_NUMPAD5);
	MAPKEY("Num6",VK_NUMPAD6);
	MAPKEY("Numpad6",VK_NUMPAD6);
	MAPKEY("Num7",VK_NUMPAD7);
	MAPKEY("Numpad7",VK_NUMPAD7);
	MAPKEY("Num8",VK_NUMPAD8);
	MAPKEY("Numpad8",VK_NUMPAD8);
	MAPKEY("Num9",VK_NUMPAD9);
	MAPKEY("Numpad9",VK_NUMPAD9);
	MAPKEY("Multiply",VK_MULTIPLY);
	MAPKEY("Add",VK_ADD);
	MAPKEY("Separator",VK_SEPARATOR);
	MAPKEY("Subtract",VK_SUBTRACT);
	MAPKEY("Decimal",VK_DECIMAL);
	MAPKEY("Divide",VK_DIVIDE);
	MAPKEY("F1",VK_F1);
	MAPKEY("F2",VK_F2);
	MAPKEY("F3",VK_F3);
	MAPKEY("F4",VK_F4);
	MAPKEY("F5",VK_F5);
	MAPKEY("F6",VK_F6);
	MAPKEY("F7",VK_F7);
	MAPKEY("F8",VK_F8);
	MAPKEY("F9",VK_F9);
	MAPKEY("F10",VK_F10);
	MAPKEY("F11",VK_F11);
	MAPKEY("F12",VK_F12);
	MAPKEY("MouseMiddle",VK_MBUTTON)
	MAPKEY("MouseX1",VK_XBUTTON1)
	MAPKEY("MouseX2",VK_XBUTTON2)

//0x88 - 0x8F unassigned range
	MAPKEY("MouseWheelUp",0x88)
	MAPKEY("MouseWheelDown",0x89)
	MAPKEY("MouseWheelLeft",0x8a)
	MAPKEY("MouseWheelRight",0x8b)

	return 0;
}

unsigned char vkFromName(const char *str)
{
	if(strlen(str)==0)
		return 0;
	if(strlen(str)==1)
		return *str;
	if(!strncmp(str,"0x",2))
		return (char)strtol(str,NULL,16);
	return strToVk(str);
}


#define ADD_SHORTCUT(str,shortcut) do { INI_READ_STRING("Battlescape Shortcuts",str,"",tmp,63); keyToShortcut[vkFromName(tmp)]=shortcut; } while(0);
#define ADD_GEO_SHORTCUT(str,shortcut) do { INI_READ_STRING("Geoscape Shortcuts",str,"",tmp,63); keyToGeoShortcut[vkFromName(tmp)]=shortcut; } while(0);
void InitShortcutsTables()
{
	char tmp[64];
	memset(keyToShortcut,0,sizeof(keyToShortcut));
	memset(keyToGeoShortcut,0,sizeof(keyToGeoShortcut));
	if (INI_READ_INT("Battlescape Shortcuts","Apply",0))
	{
		ADD_SHORTCUT("End Turn",SHORTCUT_ENDTURN);
		ADD_SHORTCUT("Multilevel View",SHORTCUT_MULTILEVELVIEW);
		ADD_SHORTCUT("Show Map",SHORTCUT_SHOWMAP);
		ADD_SHORTCUT("Center On Unit",SHORTCUT_CENTER);
		ADD_SHORTCUT("Inventory",SHORTCUT_INVENTORY);
		ADD_SHORTCUT("Kneel",SHORTCUT_KNEEL);
		ADD_SHORTCUT("Next Unit",SHORTCUT_NEXT);
		ADD_SHORTCUT("Next Unit Skip Current",SHORTCUT_NEXT_SKIP);
		ADD_SHORTCUT("View Up",SHORTCUT_VIEWUP);
		ADD_SHORTCUT("View Down",SHORTCUT_VIEWDOWN);
		ADD_SHORTCUT("Go Up",SHORTCUT_GOUP);
		ADD_SHORTCUT("Go Down",SHORTCUT_GODOWN);
		ADD_SHORTCUT("Left Menu",SHORTCUT_LEFTMENU);
		ADD_SHORTCUT("Right Menu",SHORTCUT_RIGHTMENU);
		ADD_SHORTCUT("Unit Stats",SHORTCUT_STATS);
		ADD_SHORTCUT("Options",SHORTCUT_OPTIONS);
		ADD_SHORTCUT("Lift Off",SHORTCUT_LIFTOFF);
		ADD_SHORTCUT("Reserve None",SHORTCUT_RESERVENONE);
		ADD_SHORTCUT("Reserve Snap",SHORTCUT_RESERVESNAP);
		ADD_SHORTCUT("Reserve Auto",SHORTCUT_RESERVEAUTO);
		ADD_SHORTCUT("Reserve Aimed",SHORTCUT_RESERVEAIMED);
		keyToShortcut[0]=0;
	}
	if (INI_READ_INT("Geoscape Shortcuts","Apply",0))
	{
		ADD_GEO_SHORTCUT("Rotate Right",GEO_SHORTCUT_ROTATERIGHT);
		ADD_GEO_SHORTCUT("Rotate Left",GEO_SHORTCUT_ROTATELEFT);
		ADD_GEO_SHORTCUT("Rotate Up",GEO_SHORTCUT_ROTATEUP);
		ADD_GEO_SHORTCUT("Rotate Down",GEO_SHORTCUT_ROTATEDOWN);
		ADD_GEO_SHORTCUT("Zoom In",GEO_SHORTCUT_ZOOMIN);
		ADD_GEO_SHORTCUT("Zoom Out",GEO_SHORTCUT_ZOOMOUT);
		ADD_GEO_SHORTCUT("Geo Speed1",GEO_SHORTCUT_SPEED1);
		ADD_GEO_SHORTCUT("Geo Speed2",GEO_SHORTCUT_SPEED2);
		ADD_GEO_SHORTCUT("Geo Speed3",GEO_SHORTCUT_SPEED3);
		ADD_GEO_SHORTCUT("Geo Speed4",GEO_SHORTCUT_SPEED4);
		ADD_GEO_SHORTCUT("Geo Speed5",GEO_SHORTCUT_SPEED5);
		ADD_GEO_SHORTCUT("Geo Speed6",GEO_SHORTCUT_SPEED6);
		ADD_GEO_SHORTCUT("Intercept",GEO_SHORTCUT_INTERCEPT);
		ADD_GEO_SHORTCUT("Bases",GEO_SHORTCUT_BASES);
		ADD_GEO_SHORTCUT("Graphs",GEO_SHORTCUT_GRAPHS);
		ADD_GEO_SHORTCUT("Ufopaedia",GEO_SHORTCUT_UFOPAEDIA);
		ADD_GEO_SHORTCUT("Options",GEO_SHORTCUT_OPTIONS);
		ADD_GEO_SHORTCUT("Fundings",GEO_SHORTCUT_FUNDINGS);
	}
}


void CheckShortcut()
{
	if(shortcut!=-1)
	{
		StatusBarClicked(shortcut);
		shortcut=-1;
	}
	else
	{
		CheckIfClickedOnStatusBar();
	}
}

LRESULT __stdcall MyDefWindowProcA(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	if(Msg==WM_MOUSEWHEEL)
	{
		if(*IsTacticalMode==1&&(*tactical_mainState==1||*tactical_mainState==0)&&isSavingGame==0)
		{
			int mouse_wheel = GET_WHEEL_DELTA_WPARAM(wParam);
			if ( mouse_wheel > 0 )
			{
				shortcut=keyToShortcut[0x88];
			}
			else if ( mouse_wheel < 0 )
			{
				shortcut=keyToShortcut[0x89];
			}
		}
		else if(*IsTacticalMode==0&&*geoscape_mainState==0) 
		{
			int mouse_wheel = GET_WHEEL_DELTA_WPARAM(wParam);
			if ( mouse_wheel > 0 )
			{
				geoShortcut=keyToGeoShortcut[0x88];
			}
			else if ( mouse_wheel < 0 )
			{
				geoShortcut=keyToGeoShortcut[0x89];
			}
		}
	}
	else if(Msg==WM_MOUSEHWHEEL)
	{
		if(*IsTacticalMode==1&&(*tactical_mainState==1||*tactical_mainState==0)&&isSavingGame==0)
		{
			int mouse_wheel = GET_WHEEL_DELTA_WPARAM(wParam);
			if ( mouse_wheel > 0 )
			{
				shortcut=keyToShortcut[0x8a];
			}
			else if ( mouse_wheel < 0 )
			{
				shortcut=keyToShortcut[0x8b];
			}
		}
		else if(*IsTacticalMode==0&&*geoscape_mainState==0) 
		{
			int mouse_wheel = GET_WHEEL_DELTA_WPARAM(wParam);
			if ( mouse_wheel > 0 )
			{
				geoShortcut=keyToGeoShortcut[0x8a];
			}
			else if ( mouse_wheel < 0 )
			{
				geoShortcut=keyToGeoShortcut[0x8b];
			}
		}
	}
	else if(Msg==WM_MBUTTONDOWN)
	{
		if(*IsTacticalMode==1&&(*tactical_mainState==1||*tactical_mainState==0)&&isSavingGame==0)
			shortcut=keyToShortcut[VK_MBUTTON];
		else if(*IsTacticalMode==0&&*geoscape_mainState==0) 
			geoShortcut=keyToGeoShortcut[VK_MBUTTON];
	}
	else if(Msg==WM_XBUTTONDOWN)
	{
		if(*IsTacticalMode==1&&(*tactical_mainState==1||*tactical_mainState==0)&&isSavingGame==0)
		{
			if(GET_XBUTTON_WPARAM (wParam) == XBUTTON1)
				shortcut=keyToShortcut[VK_XBUTTON1];
			else
				shortcut=keyToShortcut[VK_XBUTTON2];
		}
		else if(*IsTacticalMode==0&&*geoscape_mainState==0) 
		{
			if(GET_XBUTTON_WPARAM (wParam) == XBUTTON1)
				geoShortcut=keyToGeoShortcut[VK_XBUTTON1];
			else
				geoShortcut=keyToGeoShortcut[VK_XBUTTON2];
		}
	}
	else if(Msg==WM_KEYDOWN)
	{
#ifndef NDEBUG
		if((char)wParam==VK_ESCAPE)
			exit(-1);
#endif
		if(*IsTacticalMode==1&&(*tactical_mainState==1||*tactical_mainState==0)&&isSavingGame==0)
		{
			if(keyToShortcut[(char)wParam])
				shortcut=keyToShortcut[(char)wParam];
		}
		else if(*IsTacticalMode==0&&*geoscape_mainState==0) 
		{
			if(keyToGeoShortcut[(char)wParam])
				geoShortcut=keyToGeoShortcut[(char)wParam];
		}
		else
		{
			return 0;
		}
	}
	else if(Msg==WM_MOVE)
	{
		void SaveWindowPosition();
		SaveWindowPosition();
	}
	else if(Msg==WM_SIZE)
	{
		void SetScreenSize(int width, int height);
		SetScreenSize(LOWORD(lParam),HIWORD(lParam));
		if(wParam == SIZE_RESTORED)
		{
			void SaveWindowPosition();
			SaveWindowPosition();
		}
	}
	else if(Msg==WM_DESTROY)
	{
		exit(0);
	}

	return DefWindowProcA(hWnd, Msg, wParam, lParam);
}

void ShowTacOptionScreen()
{
//.text:00412BCE E8 6D 29 00 00                call    ShowTacOptions                  ; case 0xF
	isSavingGame=1;
	((void (*)())(0x415540))();
	isSavingGame=0;
}

void HookSpeed()
{
	if(geo_hook_disabled)
		return;

	switch(geoShortcut)
	{
		case GEO_SHORTCUT_SPEED1:
			geoShortcut = -1;
			*geo_timeSpeed = 1;
			break;
		case GEO_SHORTCUT_SPEED2:
			geoShortcut = -1;
			*geo_timeSpeed = 0xC;
			break;
		case GEO_SHORTCUT_SPEED3:
			geoShortcut = -1;
			*geo_timeSpeed = 0x3C;
			break;
		case GEO_SHORTCUT_SPEED4:
			geoShortcut = -1;
			*geo_timeSpeed = 0x168;
			break;
		case GEO_SHORTCUT_SPEED5:
			geoShortcut = -1;
			*geo_timeSpeed = 0x2D0;
			break;
		case GEO_SHORTCUT_SPEED6:
			geoShortcut = -1;
			*geo_timeSpeed = 0x4380;
			break;
	}
}

//.text:00440949 66 A1 7C F6 46 00             mov     ax, zoomGeoGlobe
__declspec(naked) void HookRotate()
{
	__asm
	{
		pusha
		call HookSpeed
		popa
		cmp geo_hook_disabled,1
		jz finish
		cmp geoShortcut,GEO_SHORTCUT_ROTATEUP
		jz rotateup
		cmp geoShortcut,GEO_SHORTCUT_ROTATEDOWN
		jz rotatedown
		cmp geoShortcut,GEO_SHORTCUT_ROTATELEFT
		jz rotateleft
		cmp geoShortcut,GEO_SHORTCUT_ROTATERIGHT
		jz rotateright
		jmp finish
rotateup:
		mov geoShortcut,-1
		pop eax
		mov eax,0x440987
		push eax
		jmp finish
rotatedown:
		mov geoShortcut,-1
		mov     edx, 0xB04
		pop eax
		mov eax,0x440A1C
		push eax
		jmp finish
rotateleft:
		mov geoShortcut,-1
		mov     edx, 0xB04
		pop eax
		mov eax,0x440AB2
		push eax
		jmp finish
rotateright:
		mov geoShortcut,-1
		mov     edx, 0xB04
		pop eax
		mov eax,0x440B42
		push eax
		jmp finish
finish:
		mov eax, zoomGeoGlobe
		mov ax,[eax]
		ret
	}
}
//.text:00440BD1 66 81 FE 01 01                cmp     si, 101h
__declspec(naked) void HookZoom()
{
	__asm
	{
		cmp geo_hook_disabled,1
		jz finish
		cmp geoShortcut,GEO_SHORTCUT_ZOOMIN
		jz zoomin
		cmp geoShortcut,GEO_SHORTCUT_ZOOMOUT
		jz zoomout
		jmp finish
zoomin:
		mov geoShortcut,-1
		pop eax
		mov eax,0x440C05
		push eax
		jmp finish
zoomout:
		mov geoShortcut,-1
		pop eax
		mov eax,0x440C70
		push eax
		jmp finish

finish:
		mov eax, zoomGeoGlobe
		mov ax,[eax]
		cmp si, 0x101
		ret
	}
}

void DisableGeoHook(FILE *f)
{
	myfflush(f);
	geo_hook_disabled = 1;
}
void EnableGeoHook()
{
	DrawMouseCursor();
	geoShortcut = -1;
	geo_hook_disabled = 0;
}

void SimulateButtonClick()
{
	if(*mouse_num_click1)
	{
		GeoHandleLeftClick();
		geoShortcut = -1;
	}
	else if(!geo_hook_disabled)
	{
		__asm pusha
		switch(geoShortcut)
		{
		case GEO_SHORTCUT_INTERCEPT:
			*mouse_xpos_click_2=0x102;
			*mouse_ypos_click_2=5;
			GeoHandleLeftClick();
			geoShortcut = -1;
			break;
		case GEO_SHORTCUT_BASES:
			*mouse_xpos_click_2=0x102;
			*mouse_ypos_click_2=5+12;
			GeoHandleLeftClick();
			geoShortcut = -1;
			break;
		case GEO_SHORTCUT_GRAPHS:
			*mouse_xpos_click_2=0x102;
			*mouse_ypos_click_2=5+24;
			GeoHandleLeftClick();
			geoShortcut = -1;
			break;
		case GEO_SHORTCUT_UFOPAEDIA:
			*mouse_xpos_click_2=0x102;
			*mouse_ypos_click_2=5+36;
			GeoHandleLeftClick();
			geoShortcut = -1;
			break;
		case GEO_SHORTCUT_OPTIONS:
			*mouse_xpos_click_2=0x102;
			*mouse_ypos_click_2=5+48;
			GeoHandleLeftClick();
			geoShortcut = -1;
			break;
		case GEO_SHORTCUT_FUNDINGS:
			*mouse_xpos_click_2=0x102;
			*mouse_ypos_click_2=5+60;
			GeoHandleLeftClick();
			geoShortcut = -1;
			break;
		}

		__asm popa
	}
}

void Shortcuts()
{
	char switchtable[]={4};

	InsertCall(0x440949,HookRotate);
	Nop(0x440949+5);

	InsertCall(0x440BD1,HookZoom);
//.text:00440BC4 0F 85 99 01 00 00             jnz     loc_440D63
	Nop(0x440BC4,6);

	InsertCall(0x4552EB,DisableGeoHook);
	InsertCall(0x4554EF,EnableGeoHook);
/*
.text:004408FF 66 39 2D 68 3F 4A 00          cmp     mouse_num_click1, bp
.text:00440906 74 05                         jz      short loc_44090D
.text:00440908 E8 13 09 01 00                call    GeoHandleLeftClick
*/
	Nop(0x4408FF,9);
	InsertCall(0x440908,SimulateButtonClick);

	//reroute key messages to DefWindowProcA
	InsertJmp(0x45E0FF,(void *)0x45E1D5);
	InsertJmp(0x45E113,(void *)0x45E1D5);
	PatchInPlace(0x45E318,switchtable,1);

	Nop(0x45E1D0,5);

	//Hook DefWindowProcA
	Nop(0x45E1E5);
	InsertCall(0x45E1E6,MyDefWindowProcA);
	Nop(0x45E0EE);
	InsertCall(0x45E0EF,MyDefWindowProcA);

	//Shortcut handling
	InsertCall(0x42A82F,CheckShortcut);

	//Disable shortcuts when typing savegame name
	InsertCall(0x412BCE,ShowTacOptionScreen);

	InitShortcutsTables();

}
